/* factorials.cpp is a driver program to test the Factorial 
 * function.  It computes any number of factorials.
 * By: Joel C. Adams, Summer 2001.
 * For: C++ An Introduction to Computing 3/e.
 ************************************************************/

#include <iostream>        // cin, cout, <<, >>
using namespace std;

int factorial(int n);

int main()
{
   for(;;)
   {
      cout << "To compute n!, enter n (a negative number to quit): ";
      int theNumber;
      cin >> theNumber;

      if (theNumber < 0) break;

      cout << theNumber << "! = "
           << factorial(theNumber) << "\n\n";
   }



   return 0;
}

/* factorial computes the factorial of a nonnegative integer. 
 *     
 * Receive:      n, an integer
 * Precondition: n is nonnegative
 * Return:       n!
 *************************************************************/

#include <cassert>             // assert()
using namespace std;

int factorial(int n)
{
   assert(n >= 0);

   int product = 1;

   for (int count = 2; count <= n; count++)
      product *= count;

   return product;
}
